## davegnukem 1.0.3

=== Makefile ===
#
# David Joffe
# Copyright 1998-2022 David Joffe
# Created 1998/12
# Makefile for Dave Gnukem
#
# 2016-10: Get this working on Mac OS X [dj]
# 2017-07-29: Remove obsolete standalone-editor-related stuff, and add new thing_monsters.o
# 2022-11-25: Cleanup and fix targets for new debian dir (dist, install and uninstall)
#

BIN = davegnukem
# 'version string history' here:
# "v1.0 - 3 Apr 2018" [version 1]
# "v1.0.1 - 25 Apr 2020"
# "v1.0.2 - 19 Nov 2022" [<- last version on SDL1 - about to update to SDL2]
# "v1.0.3 - 19 Nov 2022" [New version number for SDL2 version with Matteo Bini SDL2 commit merged in] (1.0.3-dev, working towards official new 1.0.3 stable)
# "v1.0.3 - 29 Nov 2022" First official stable version with Matteo Bini's updates to SDL2, and new improved Debian packaging files by Matteo Bini
V_NUM    = 1.0.3
V_DATE   = 29 Nov 2022
VERSION  = v$(V_NUM) - $(V_DATE)

# paths
PREFIX   = /usr/local
DATA_DIR = $(PREFIX)/share/games/$(BIN)/# the trailing slash is required for paths in the source

LIBS    = `sdl2-config --libs` -lSDL2_mixer
LDFLAGS = $(LIBS)

CPPFLAGS = -DDATA_DIR=\"$(DATA_DIR)\" -DVERSION=\"'$(VERSION)'\"

CXX = g++

OBJ = $(shell find src -iname '*.cpp' -type f | sed 's/\.cpp$$/.o/')

# debug
#CXXFLAGS = -ggdb -DDEBUG -std=c++14 -Wall `sdl2-config --cflags` $(CPPFLAGS)
CXXFLAGS = -O2 -std=c++14 -Wall `sdl2-config --cflags` $(CPPFLAGS)

all: options davegnukem

options:
	@echo davegnukem build options:
	@echo "CXXFLAGS = $(CXXFLAGS)"
	@echo "LDFLAGS  = $(LDFLAGS)"
	@echo "CXX      = $(CXX)"

%.o: %.cpp
	$(CXX) $(CXXFLAGS) -c $< -o $@

davegnukem: $(OBJ)
	$(CXX) -o $(BIN) $(OBJ) $(LDFLAGS)

clean:
	rm -f $(BIN) $(BIN)-$(V_NUM).tar.gz
	find src -name '*.o' | xargs rm -f

dist: clean
	mkdir $(BIN)-$(V_NUM)
	ls | sed '/data/d; /$(BIN)-$(V_NUM)/d' | xargs -I {} cp -R {} $(BIN)-$(V_NUM)
	tar cf $(BIN)-$(V_NUM).tar $(BIN)-$(V_NUM)
	gzip $(BIN)-$(V_NUM).tar
	rm -fr $(BIN)-$(V_NUM)

install: 
	# binary
	mkdir -p $(DESTDIR)$(PREFIX)/games
	cp -f $(BIN) $(DESTDIR)$(PREFIX)/games
	chmod 755 $(DESTDIR)$(PREFIX)/games/$(BIN)
	# data
	mkdir -p $(DESTDIR)$(DATA_DIR)
	cp -fR data/* $(DESTDIR)$(DATA_DIR)
	rm -f $(DESTDIR)$(DATA_DIR)README.md
	find $(DESTDIR)$(DATA_DIR) -type d | xargs chmod 755
	find $(DESTDIR)$(DATA_DIR) -type f | xargs chmod 644
	# data doc
	mkdir -p $(DESTDIR)$(PREFIX)/share/doc/$(BIN)-data
	cp -f data/README.md $(DESTDIR)$(PREFIX)/share/doc/$(BIN)-data
	chmod 644 $(DESTDIR)$(PREFIX)/share/doc/$(BIN)-data/README.md
	# desktop file
	mkdir -p $(DESTDIR)$(PREFIX)/share/applications
	cp -f debian/desktop/$(BIN).desktop $(DESTDIR)$(PREFIX)/share/applications
	chmod 644 $(DESTDIR)$(PREFIX)/share/applications/$(BIN).desktop
	# doc
	mkdir -p $(DESTDIR)$(PREFIX)/share/doc/$(BIN)
	cp -f HISTORY.txt README.md $(DESTDIR)$(PREFIX)/share/doc/$(BIN)
	chmod 644 $(DESTDIR)$(PREFIX)/share/doc/$(BIN)/HISTORY.txt \
		$(DESTDIR)$(PREFIX)/share/doc/$(BIN)/README.md
	# icon
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps
	cp -f debian/icons/hicolor/32x32/apps/$(BIN).png $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps
	chmod 644 $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps/$(BIN).png
	# manual page
	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man6
	sed 's/VERSION/$(VERSION)/' < debian/$(BIN).6 > $(DESTDIR)$(PREFIX)/share/man/man6/$(BIN).6
	chmod 644 $(DESTDIR)$(PREFIX)/share/man/man6/$(BIN).6

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/games/$(BIN) 
	rm -fr $(DESTDIR)$(PREFIX)/share/games/$(BIN) 
	rm -fr $(DESTDIR)$(PREFIX)/share/doc/$(BIN)-data
	rm -f $(DESTDIR)$(PREFIX)/share/applications/$(BIN).desktop
	rm -fr $(DESTDIR)$(PREFIX)/share/doc/$(BIN)
	rm -f $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps/$(BIN).png	
	rm -f $(DESTDIR)$(PREFIX)/share/man/man6/$(BIN).6

=== debian/changelog ===
davegnukem (1.0.3-4) unstable; urgency=medium

  * debian/appstream/com.djoffe.davegnukem.metainfo.xml:
    - Change AppStream metadata license.
  * debian/patches/01_big-endian.patch:
    - Add commit to Forwarded header.
  * debian/patches/03_reproducibility.patch:
    - Add patch to build reproducibly.
  * debian/rules:
    - Replace `$(MAKE) *` with `dh_auto_* --` to fix parallel build. Thanks to
      Plasma for the patch (Closes: #1031113).
 -- Matteo Bini <matteobin@tiepi.it>  Wed, 22 Feb 2023 19:45:48 +0100

davegnukem (1.0.3-3) unstable; urgency=medium

  * debian/appstream/com.djoffe.davegnukem.metainfo.xml:
    - Add AppStream upstream metadata.
  * debian/icons/hicolor/128x128/apps/davegnukem.png:
    - Add bigger icon for AppStream.
  * debian/patches/02_appstream.patch:
    - Add patch to install and uninstall AppStream metadata and bigger icon
      too.

 -- Matteo Bini <matteobin@tiepi.it>  Thu, 02 Feb 2023 23:01:07 +0100

davegnukem (1.0.3-2) unstable; urgency=medium

  * debian/control:
    - Bump Standards-Version to 4.6.2.
  * debian/patches/01_big-endian.patch:
    - Add patch to build on big-endian systems, disabling retro settings
      (Closes: #1029224). Retro settings for big-endian will be added later.

 -- Matteo Bini <matteobin@tiepi.it>  Fri, 20 Jan 2023 19:20:06 +0100

davegnukem (1.0.3-1) unstable; urgency=low

  * Initial release (Closes: #1009780)

 -- Matteo Bini <matteobin@tiepi.it>  Tue, 29 Nov 2022 11:01:36 +0100

=== debian/control ===
Source: davegnukem
Section: games
Priority: optional
Maintainer: Matteo Bini <matteobin@tiepi.it>
Build-Depends: debhelper-compat (= 13),
               libsdl2-dev,
               libsdl2-mixer-dev
Standards-Version: 4.6.2
Homepage: https://djoffe.com/gnukem/
Rules-Requires-Root: no

Package: davegnukem
Architecture: any
Depends: davegnukem-data (= ${source:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Retro-style 2D scrolling platform shooter
 Dave Gnukem is an open source retro-style 2D scrolling platform shooter,
 inspired by and similar to Duke Nukem 1. It currently runs on Windows, macOS,
 Linux and various other platforms. It is written in C++ using SDL library and
 it features an integrated level editor as well. This game is not really a
 clone or remake, it is probably most akin to a parody.

Package: davegnukem-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Suggests: davegnukem
Description: Data files for davegnukem
 This package contains the data files required by the davegnukem package.

Package: davegnukem-datasrc
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Suggests: davegnukem-data
Description: Data source files for davegnukem
 This package contains the data source files used to create the graphics for
 the Dave Gnukem video game.
 .
 You don't need this package to play nor to build the game: it contains the
 original Photoshop files that are exported to TGA in the game's data folder.
 This package would only be necessary if you intend to edit the game's sprites.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

SHELL := sh -e

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- PREFIX=/usr

override_dh_auto_install:
	dh_auto_install -- DESTDIR=$(CURDIR)/debian/davegnukem PREFIX=/usr

	mkdir -p debian/davegnukem-data/usr/share/games
	mv debian/davegnukem/usr/share/games/davegnukem debian/davegnukem-data/usr/share/games
	mkdir -p debian/davegnukem-data/usr/share/doc
	mv debian/davegnukem/usr/share/doc/davegnukem-data debian/davegnukem-data/usr/share/doc
	
	mkdir -p debian/davegnukem-datasrc/usr/share/games/davegnukem
	cp -R datasrc debian/davegnukem-datasrc/usr/share/games/davegnukem/src
	rm debian/davegnukem-datasrc/usr/share/games/davegnukem/src/README.md
	mkdir -p debian/davegnukem-datasrc/usr/share/doc/davegnukem-datasrc
	cp datasrc/README.md debian/davegnukem-datasrc/usr/share/doc/davegnukem-datasrc
